// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template unit_test.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver10;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import static org.junit.Assert.*;
import org.junit.Test;
import org.junit.Before;
import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;
import org.hamcrest.CoreMatchers;



public class OFHelloVer10Test {
    OFFactory factory;

    final static byte[] HELLO_SERIALIZED =
        new byte[] { 0x1, 0x0, 0x0, 0x8, 0x12, 0x34, 0x56, 0x78 };

    @Before
    public void setup() {
        factory = OFFactoryVer10.INSTANCE;
    }

    @Test
    public void testWrite() {
        OFHello.Builder builder = factory.buildHello();
        builder.setXid(0x12345678);
        OFHello hello = builder.build();
        ChannelBuffer bb = ChannelBuffers.dynamicBuffer();
        hello.writeTo(bb);
        byte[] written = new byte[bb.readableBytes()];
        bb.readBytes(written);

        assertThat(written, CoreMatchers.equalTo(HELLO_SERIALIZED));
    }

    @Test
    public void testRead() throws Exception {
        OFHello.Builder builder = factory.buildHello();
        builder.setXid(0x12345678);
        OFHello helloBuilt = builder.build();

        ChannelBuffer input = ChannelBuffers.copiedBuffer(HELLO_SERIALIZED);

        // FIXME should invoke the overall reader once implemented
        OFHello helloRead = OFHelloVer10.READER.readFrom(input);
        assertEquals(HELLO_SERIALIZED.length, input.readerIndex());

        assertEquals(helloBuilt, helloRead);
   }

   @Test
   public void testReadWrite() throws Exception {
       ChannelBuffer input = ChannelBuffers.copiedBuffer(HELLO_SERIALIZED);

       // FIXME should invoke the overall reader once implemented
       OFHello hello = OFHelloVer10.READER.readFrom(input);
       assertEquals(HELLO_SERIALIZED.length, input.readerIndex());

       // write message again
       ChannelBuffer bb = ChannelBuffers.dynamicBuffer();
       hello.writeTo(bb);
       byte[] written = new byte[bb.readableBytes()];
       bb.readBytes(written);

       assertThat(written, CoreMatchers.equalTo(HELLO_SERIALIZED));
   }

}
